



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>iOS实现类似于歌词进度效果</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">iOS实现类似于歌词进度效果</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-24 10:10:32 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>先看效果</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/683896/201611/683896-20161124112455221-1189663131.gif" /></p>
<p>这里关键的地方在于镂空文字的实现，可以用UILabel的drawRect方法。</p>
<p>.h文件</p>
<div>
<pre class="prettyprint linenums">@interface HollowLabel : UILabel

@end</pre>
</div>
<p>.m文件</p>
<div>
<pre class="prettyprint linenums">@interface HollowLabel(){<br />
    NSString *_labelText;<br />
    UIFont *_labelFont;<br />
    UIColor *_labelBackgroundColor;<br />
    CGRect _labelRect;<br />
}

@end

@implementation HollowLabel

-(void)setText:(NSString *)text{<br />
    _labelText = text;<br />
}

-(void)setFont:(UIFont *)font{<br />
    _labelFont = font;<br />
}

-(void)setBackgroundColor:(UIColor *)backgroundColor{<br />
    _labelBackgroundColor = backgroundColor;<br />
}

//重写该方法，否则该方法会出问题<br />
-(void)sizeToFit{

}

//禁止使用该方法初始化<br />
-(instancetype)init{<br />
    return nil;<br />
}

-(instancetype)initWithFrame:(CGRect)frame{<br />
    if (self = [super initWithFrame:frame]) {<br />
        _labelRect = frame;<br />
    }<br />
    return self;<br />
}</pre>
</div>
<p>重要的是drawRect的实现</p>
<div>
<pre class="prettyprint linenums">-(void)drawRect:(CGRect)rect{<br />
    CGContextRef ctx = UIGraphicsGetCurrentContext();<br />
    [self drawHallowLabel:_labelText inRect:_labelRect inContext:ctx];<br />
}

-(void)drawHallowLabel:(NSString *)labText inRect:(CGRect )labrect inContext:(CGContextRef )context{<br />
    //记录上下文的当前状态<br />
    CGContextSaveGState(context);<br />
    //设置混合色<br />
    CGContextSetBlendMode(context, kCGBlendModeDestinationOut);<br />
    //lable上边添加label<br />
    UILabel *lab = [[UILabel alloc]initWithFrame:labrect];<br />
    lab.text = labText;<br />
    lab.backgroundColor = _labelBackgroundColor;<br />
    lab.font = _labelFont;<br />
    lab.textAlignment = NSTextAlignmentCenter;

    [lab.layer drawInContext:context];<br />
    //去除堆栈顶部的状态，返回到之前的上下文状态<br />
    CGContextRestoreGState(context);<br />
}</pre>
</div>
<p>实现镂空文字后，再在HollowLabel下贴图，一层背景view，一层变色view，用NSTimer改变【变色view】的宽度就可以实现歌词效果。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m96o37n9.html">梳理delegate相关概念</a>
		</li>
						<li><a href="https://www.batexi.com/a/m9616gj8.html">&lbrack;BZOJ 2631&rsqb;tree</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdejg109.html">jquery ajax跨域请求详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xjor09.html">看我是一只IT小小鸟有感</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xj5w08.html">DevExpress12&period;2&period;6 安装顺序记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1ww138.html">TCPSocket v1&period;0 for cocos2d-x下载</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xg2nn9.html">【原创】lua的module的一些点</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1lnve9.html">jsp &amp;lt&semi;&percnt;&excl; &percnt;&amp;gt&semi; 与 &amp;lt&semi;&percnt; &percnt;&amp;gt&semi; 区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde276v9.html">Codeforces 161D Distance in Tree</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1vxooq.html">PHP草根论之设计模式-訪问者模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpojrr9.html">Apache的htaccess文件出现500错误的原因</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zn17x9.html">Java Swing客户端小项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k7rp49.html">multiWriter&period;go</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvzrlr8.html">jQuery合并同一列中相同文本的相邻单元格</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwe2r78.html">&amp;lt&semi;&amp;lt&semi;梦断代码&amp;gt&semi;&amp;gt&semi;阅读笔记二</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdw66yz9.html">python urllib库</a>
		</li>
						<li><a href="https://www.batexi.com/a/953p42v8.html">RESTful URL设计指南（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9532yez8.html">Bate版本控制报告</a>
		</li>
						<li><a href="https://www.batexi.com/a/96mjzg48.html">关于JavaScript对象，你所不知道的事（二）- 再说属性</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnd1kj28.html">&lbrack;转&rsqb;nginx虚拟目录&lpar;alias与root的区别&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/5qxyo0j9.html">ArcSDE安装步骤及问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdkzkj9.html">linux下wps，系统缺失字体：wingdings、wingdings 2、wingdings3</a>
			</li>
						<li><a href="https://www.batexi.com/a/49ggzz09.html">使用php技术实现无刷新的上传文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qww4vlq.html">Could not find the following Boost libraries&colon; boost&lowbar;python3</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7d0ogq.html">Permission denied&colon;multiarray&period;cp35-win&lowbar;amd64&period;pyd（tensorflow0&period;12&period;0在windows下安装）</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q23ypl9.html">webpack配置备份</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93762z8.html">SOC芯片的FPGA原型验证</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnw0wjq.html">Chrome浏览器官方下载地址</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gg0nl9.html">开始学java痛苦之旅开启  12-31日   第一章节笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlvd219.html">linux无线配置</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
